'use strict';

const { interfaces: Ci, classes: Cc, results: Cr, utils: Cu } = Components;

let { XPCOMUtils } = Cu.import('resource://gre/modules/XPCOMUtils.jsm', {});
let { Services } = Cu.import('resource://gre/modules/Services.jsm', {});


function ProtocolHandler(){
}

ProtocolHandler.prototype = {

    scheme: 'foobar',

    defaultPort: -1,

    protocolFlags: Ci.nsIProtocolHandler.URI_NORELATIVE |
                   Ci.nsIProtocolHandler.URI_NOAUTH |
                   Ci.nsIProtocolHandler.URI_LOADABLE_BY_ANYONE,

    createInstance(outer, iid) {
        if(outer){
            throw Cr.NS_ERROR_NO_AGGREGATION;
        }

        return this.QueryInterface(iid);
    },


    allowPort() {
        return false;
    },

    newURI(aSpec, aCharset, aBaseURI) {
        let uri  = Cc["@mozilla.org/network/simple-uri;1"].createInstance(Ci.nsIURI);
        uri.spec = aSpec;
        return uri;
    },

    newChannel(aURI) {
        let newURI = 'about:config';
        let redirectee = Services.io.newURI(newURI, null, null);
        let channel = Services.io.newChannelFromURI(redirectee);

        channel.originalURI = aURI;

        Services.console.logStringMessage('Load: ' + aURI.spec);

        return channel;
    },


    classDescription: 'test scheme component',

    contractID: '@mozilla.org/network/protocol;1?name=foobar',

    classID: Components.ID('{3c0cd1b2-2f16-4472-bdd2-1416380ab3a2}'),

    QueryInterface: XPCOMUtils.generateQI([
        Ci.nsISupportsWeakReference,
        Ci.nsIProtocolHandler
    ])
};


let registrar = Components.manager.QueryInterface(Ci.nsIComponentRegistrar);
let handler = ProtocolHandler.prototype;

try{
    registrar.registerFactory(handler.classID, handler.classDescription, handler.contractID, handler);
    Services.console.logStringMessage('foobar: scheme has been registered.');
}catch(ex){}
