'use strict';

const { interfaces: Ci, classes: Cc, results: Cr, utils: Cu } = Components;

let { Services } = Cu.import('resource://gre/modules/Services.jsm', {});
let { OS } = Cu.import('resource://gre/modules/osfile.jsm', {});

let dirs = [
    ['localProfileDir', 'ProfLD'],
    ['profileDir', 'ProfD'],
    ['userApplicationDataDir', 'UAppData'],
    ['winAppDataDir', 'AppData'],
    ['winStartMenuProgsDir', 'Progs']
];

let loc = content.location.href;

for(let [constProp, dirKey] of dirs){
    // Try to get directory pathes using nsIDirectoryService.
    try{
        let path = Services.dirsvc.get(dirKey, Ci.nsIFile).path;

        content.console.log(`[${loc}][Services] ${constProp}: ${path}`);
    }catch(ex){
        content.console.error(loc, ex);
    }

    // Try to get directory pathes using osfile.jsm
    try{
        let path = OS.Constants.Path[constProp];

        content.console.log(`[${loc}][osfile.jsm] ${constProp}: ${path}`);
    }catch(ex){
        content.console.error(loc, ex);
    }
}
